// This file has been autogenerated from a class added in the UI designer.

using System;
using Foundation;
using UIKit;
using CoreAnimation;
using CoreGraphics;
using VixarEngine;

namespace MetalTexturedQuad
{
	public partial class ImageViewController : UIViewController
	{
		CADisplayLink _timer;
		double _timeSinceLastDrawPreviousTime;
		bool _gameLoopPaused;
		bool _firstDrawOccurred;
		#pragma warning disable 414
		double _timeSinceLastDraw;
		#pragma warning restore 414

		Renderer _renderer;

		NSObject _didEnterBackgroundObserver;
		NSObject _willEnterForegroundObserver;

		bool Paused {
			get {
				return _gameLoopPaused;
			}

			set {
				if (_gameLoopPaused == value)
					return;

				if (_timer == null)
					return;

				_gameLoopPaused = _timer.Paused = value;
			}
		}

		Renderer Renderer { get; set; }

		public ImageViewController (IntPtr handle) : base (handle)
		{
		}

		public void DispatchGameLoop ()
		{
			_timer = CADisplayLink.Create (Gameloop);
			_timer.FrameInterval = 1;
			_timer.AddToRunLoop (NSRunLoop.Main, NSRunLoop.NSDefaultRunLoopMode);
		}

		public void Gameloop ()
		{
			if (!_firstDrawOccurred) {
				_timeSinceLastDraw = 0.0;
				_timeSinceLastDrawPreviousTime = CAAnimation.CurrentMediaTime ();
				_firstDrawOccurred = true;
			} else {
				double currentTime = CAAnimation.CurrentMediaTime ();
				_timeSinceLastDraw = currentTime - _timeSinceLastDrawPreviousTime;
				_timeSinceLastDrawPreviousTime = currentTime;
			}

			((ImageView)View).Display ();
		}

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();

			_renderer = new Renderer();
			var renderView = (ImageView)View;
			renderView.Renderer = _renderer;

			// load all renderer assets before starting game loop
			_renderer.Configure(renderView);
		}

		public override void ViewWillDisappear (bool animated)
		{
			base.ViewWillDisappear (animated);

			_didEnterBackgroundObserver.Dispose ();
			_willEnterForegroundObserver.Dispose ();
		}

		public override void ViewWillAppear (bool animated)
		{
			Renderer = _renderer;

			base.ViewWillAppear (animated);

			_didEnterBackgroundObserver = UIApplication.Notifications.ObserveDidEnterBackground (DidEnterBackground);
			_willEnterForegroundObserver = UIApplication.Notifications.ObserveWillEnterForeground (WillEnterForeground);

			// run the game loop
			DispatchGameLoop ();
		}

		void DidEnterBackground (object sender, NSNotificationEventArgs notification)
		{
			Paused = true;
		}

		void WillEnterForeground (object sender, NSNotificationEventArgs notification)
		{
			Paused = false;
		}

		public override void TouchesBegan(NSSet touches, UIEvent evt)
		{
			base.TouchesBegan(touches, evt);

//			UITouch touch = (UITouch)touches.AnyObject;
//			_touchPos = touch.LocationInView(View);

            _renderer._touch = true;
		}

		public override void TouchesMoved(NSSet touches, UIEvent evt)
		{
			base.TouchesMoved(touches, evt);
        }

        public override void TouchesEnded(NSSet touches, UIEvent evt)
        {
            base.TouchesEnded(touches, evt);

            _renderer._touch = false;
        }
	}
}
